デブノート 開発者向け情報
===============================================================================

目次
-------------------------------------------------------------------------------

* [ファイル構成と概要](#files)
* [開発に必要な環境](#devenv)
* [配布用パッケージの作成方法](#build)


<a name="files"> ファイル構成と概要
-------------------------------------------------------------------------------

### ディレクトリ
* backup : デフォルトで用意されているポーズ情報
* icon   : アイコン
* tests  : テスト。あまりしてない

### ファイル
* autoshift.py :  
  デフォルトで用意されているポーズ情報や外部から持ってきたポーズ情報を使用する場合、音声ファイルの取り込み方によりズレが生じる。それを自動的に修正するための処理が書かれている

* backup.py :  
  バックアップ機能

* bufferedwindow.py :  
  画面のチラツキを抑えるための機能。  

* CHANGES.md :  
  変更履歴

* conf.py :
  設定ファイルの処理  
  新規項目の追加はconf_data変数に追加すればできる。

* convtable.py :  
  ポーズなしの再生位置からポーズありの再生位置へ変換するためのテーブル。逆の変換も行う。  
  このテーブルをpausewaveに設定することで擬似的にポーズ入りの音声が再現される。

* DEV_NOTE.md :  
  このファイル

* distall.py :  
  配布用パッケージを作成する処理

* ffmpeg.py :  
  wav形式以外のファイルを処理するためにffmpegを使用している。
  そのための機能。

* findsnd.py :  
  音声ファイルから音声がある部分を見つけて自動的にポーズ情報をつくる機能  
  単体のプログラムとしても使用できる。

* gui.xrc :  
  フォームやツールバーなどのGUIの設定が記述されたXMLファイル  
  wxPythonのXRCEDエディタで編集できる。  
  XRCEDはPythonをインストールしたディレクトリの中のScriptsの中にある。

* icon.ico :  
  プログラムのアイコン

* insp.py :  
  音声ファイルとポーズ情報からポーズ入り音声を作成する機能  
  単体のプログラムとしても使用できる。

* inspause.py :  
  プログラムのメインファイル  
  wxPythonのAppアプリーケーションを定義している。  
  ユーザとのグラフィカルな処理はここでしている。

* inspause_template.wxs :  
  Windowsのインストーラをつくるために必要なファイル  
  distall.pyで使われている。

* label.py :  
  ラベルとは、１つのポーズ範囲か１つの音声の削除範囲のこと。  
  （波形を覆う１つの矩形で表されている）

* labels.py :  
  １つの音声ファイルにあるラベルをリストにまとめたもの

* labelsmanager.py :  
  ラベルを編集したときに「元に戻す」機能をつけるための履歴を管理する

* labelswindow.py :  
  volumewindowのサブクラス  
  ラベルを表示する。

* LICENSE.txt :  
  ライセンス情報。GPL2

* MANIFEST.in :  
  ソースパッケージに格納されるファイルのリスト（ソースファイル以外）  
  以下のコマンドを実行したときにコピーされる。

    $ python setup.py sdist

* maplabels.py :  
  ラベルファイルをアプリデータフォルダで一元管理するための処理  
  ver2.04以前は、ラベルファイルは音声フォルダ直下に置かれていた。

* myfile.py :  
  ファイル関連のユーティリティ

* mylog.py :  
  ログテキストコントロールとログファイルの両方に同時に書くための処理

* pausewave.py :  
  Python標準のwaveか自作Ffmpeg_readの音声のラッパー  
  擬似的にポーズ機能を実現している。

  たとえば10秒の音声をラップするとする。  
  そして、3秒の位置から5秒間ポーズが入ると記述されたconvtableをそのラッパーに設定する。  
  そのときラッパーから音声を読み出すと0秒から3秒の間は普通にラップしている音声を読み込んで返す。  
  3秒のところにくると無音のデータを返す。  
  8秒のところにくるとまた元の音声データの音声を返す。  
  ここでの音声は、前回、3秒のところで中断していたのでそこからのものになる。  
  15秒までくると再生が終わる。

* README.md :  
  README。拡張子がmdとなっているがこれはMarkdownという形式のテキスト。

* setup.py :  
  パッケージ作成のための処理

* volume.py :  
  音声からボリュームを作成する

* volumewindow.py :  
  ボリュームの波形を表示するためのウィンドウ  
  ここで言うウィンドウはwxPythonの用語としてのウィンドウ。  
  他のところではコントロールと呼ばれる。  
  逆に他のところで言うところのウィンドウは、wxPythonではフレームという。

* waveplayer.py :  
  音声を再生するプレーヤ  
  マルチスレッドで再生する。

* wx_utils.py :  
  wxPython関連のユーティリティ  
  wxPythonのイベントとハンドラを結びつけるためのバインダを提供している。


<a name="devenv"> 開発に必要な環境
-------------------------------------------------------------------------------

### 言語
* python 2.7

### Pythonパッケージ
* wxPython
* pyaudio
* py2exe
* win32

### その他
* WiX   （Windowsインストーラを作成するソフト）
* ffmpeg.exe  （wav形式以外の読み書きテスト用）


PATH環境変数に追加しておくものWiX、pythonのScripts。

gui.xrcはXRCEDで編集する。

<a name="build"> 配布用パッケージの作成方法
-------------------------------------------------------------------------------

### 全パッケージの作成
（Windowsインストーラ、WindowsZip、ソースパッケージの３つ）  

    $ python setup.py all


以下は、開発時に特定のパッケージだけが必要な場合に使用する

### ソースパッケージの作成
    $ python setup.py sdist


### Windows実行ファイルの作成
    $ python setup.py py2exe
